﻿/*
aardio-electron 专用 websocket/json-rpc/aasdl 客户端
可以让aardio,js在electron主进程、渲染进程都可以相互调用函数
关于 aasdl : http://bbs.aardio.com/doc/aasdl/
*/
var startEnviron = JSON.parse(process.env.aarStartEnviron);
exports.startEnviron = startEnviron;

function isRendererProcess () {  
  if (typeof(process) === 'undefined') return true 
  if (!process) return true 
  if (!process.type) return false 
  return process.type === 'renderer'
}

let ws;
if(!isRendererProcess ()){ 
    require('module').globalPaths.push(startEnviron.nodePath);
    
    const {app} = require('electron');
    let WebSocket = require("ws.asar")
    ws = new WebSocket(exports.startEnviron.rpcMainServerUrl); //连接到"/rpc/main"
   
    if( typeof(startEnviron.args) ===  "object"){
       for(var k in startEnviron.args){ 
            app.commandLine.appendSwitch(k, startEnviron.args[k] + "" )
       }
    }  
}
else{ 
    ws = new WebSocket(exports.startEnviron.rpcServerUrl); //连接到"/rpc"
}

let events = require('events');
let eventEmitter =  new events.EventEmitter();
let rpcNotifications = new Object(); 
let rpcCallbacks = new Array(); 
 
ws.onopen = function(e){ 
    xcall("?").then(
        function(aasdl,error){ 

            var paseraasdl = function(obj,ex,pk){
                for(var k in obj){
                    let method = k;
                    if( typeof(pk) == "string" ) method = pk + "." + k;

                    if( typeof(obj[k]) == "object" ){
                        ex[k] = {};
                        paseraasdl(obj[k],ex[k],method);
                        continue;
                    }

                    ex[k] = function(){
                        Array.prototype.unshift.call(arguments,method);
                        return xcall.apply(ex,arguments)
                    }
                }
            }
                
            paseraasdl(JSON.parse(aasdl), exports);

            if(isRendererProcess()) xcall("onLoadUrl",document.location.href );
            else{ 
                let win; 
                const {app, BrowserWindow} = require('electron') 
                createWindow = function(){ 
                    let aardio = exports;
                    win = new BrowserWindow( startEnviron.browserWindow)
                    aardio.hwndElectron = win.getNativeWindowHandle().readInt32LE();
                    aardio.main_initNativeWindow( aardio.hwndElectron );

                    global.mainNativeWindow = win;
                    win.loadURL( startEnviron.indexUrl) 

                    win.on('closed', () => {   
                        ws = null;
                        global.mainNativeWindow = null  
                        win = null
                    })
                      
                    win.once('ready-to-show', () => { 
                        win.show();   
                        aardio.main_showNativeWindow( aardio.hwndElectron ) 
                    })

                    eventEmitter.emit("ready",win)
                }

                if(!global.mainNativeWindow){
                    if( app.isReady() ) createWindow();
                    else app.on('ready', createWindow);
                }
                else{
                    eventEmitter.emit("ready",global.mainNativeWindow)
                }
            }
        }
    )

}
ws.onclose = function(e){ }
ws.onerror = function(e){ console.log(e) }
ws.onmessage = function(e){
    var rep = JSON.parse(e.data)
    if (typeof(rep.id) == "number" ){ 
        var callback = rpcCallbacks[rep.id]; 
        if(callback){
            callback(rep.result,rep.error);
            rpcCallbacks.splice(rep.id,1);  
        }
    }
    else if (typeof(rep.method) == "string" ){ 
        var notify = rpcNotifications[rep.method]; 
        if(notify){
            var result = notify.apply(ws,rep.params); 
            if( rep.id ){
                var clientRep = JSON.stringify({
                    id : rep.id,
                    jsonrpc : "2.0",
                    result : result
                });  
                 ws.send(clientRep); 
            }
        }
    }
}

function on (method,notify) {
    if( method == "ready" ) eventEmitter.on(method,notify);
    else rpcNotifications[method] = notify;
}

function xcall () {
    
    var req = JSON.stringify({
        method : Array.prototype.shift.call(arguments),
        jsonrpc : "2.0",
        params : Array.prototype.slice.apply(arguments),
        id : rpcCallbacks.length
    });
    
    return  new Promise(function (resolve, reject) {
        
        rpcCallbacks.push( 
            function(result,error){
                if( error ){
                    reject(error);
                }
                else {
                    resolve(result);
                } 
            }
        );
         
        ws.send(req);
    }); 
}

exports.call = xcall;
exports.on = on;
exports.startEnviron = startEnviron;
